// generuje K_16,16 a 20 prepojenych kopii K_7

#include <stdio.h>
#include <stdlib.h>

#define DIMK 7
#define KOPII 20
#define HRAN 20
#define DIMC 16 // rozmer particie

#define VRCH (DIMK*KOPII+2*DIMC)
#define POCHRAN ( ((DIMK*(DIMK-1))/2)*KOPII + HRAN + DIMC*DIMC )

int main(void){
  int i,j,x,y;
  int G[KOPII+5][KOPII+5];

  bzero(G,sizeof(G));

  srand(47);

  for (i=0;i<HRAN;i++) {
    x=1+(random()%KOPII);
    y=1+(random()%KOPII);
    while ((x==y)||(G[x][y])) {
      x=1+(random()%KOPII);
      y=1+(random()%KOPII);
    }
    G[x][y]=G[y][x]=1;
  }

  printf("%d %d\n",VRCH,POCHRAN);

  // vypiseme K_7
  
  for (x=0;x<KOPII;x++)
    for (i=0;i<DIMK;i++)
      for (j=i+1;j<DIMK;j++)
        if (random()%2) {
          printf("%d %d\n",DIMK*x+1+i,DIMK*x+1+j);
        } else {
          printf("%d %d\n",DIMK*x+1+j,DIMK*x+1+i);
        }

  // porobime hrany medzi nimi

  for (i=1;i<=KOPII;i++) for (j=i+1;j<=KOPII;j++) if (G[i][j]) {
    x=(i-1)*DIMK + (random()%DIMK) + 1;
    y=(j-1)*DIMK + (random()%DIMK) + 1;
    if (random()%2) {
      printf("%d %d\n",x,y);
    } else {
      printf("%d %d\n",y,x);
    }
  }

  // vypiseme K_{16,16}

  for (i=0;i<DIMC;i++) for (j=0;j<DIMC;j++) {
    x=i+DIMK*KOPII+1;
    y=j+DIMK*KOPII+1+DIMC;
    if (random()%2) {
      printf("%d %d\n",x,y);
    } else {
      printf("%d %d\n",y,x);
    }
  }
  
}
