#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>

#define MAXN 1047

typedef struct { int v1,v2,u1,u2,del; } thrana;
typedef struct { int from,to,del; } ttah;

int N,M,i,j,k,w1,w2,v,start,R,P,zle;
int ww[2];
thrana* E;
int *V[MAXN];
int deg[MAXN],used[MAXN],kde[MAXN],prichod[MAXN],sef[MAXN];
int tahl;
ttah *tah;

int Sef(int koho) // kto je jeho "velky sef"
{ if (sef[koho]==koho) { return koho; }
  else { sef[koho]=Sef(sef[koho]); return sef[koho]; } 
}

int JeFree(int v, int kd) // je tato hrana nepouzita?
{ return (E[V[v][kd]].u1+E[V[v][kd]].u2==0); }

int Mozem(int v, int kd) { // mozem touto hranou ist?
  thrana hr=E[V[v][kd]];

  if (V[v][kd]==prichod[v]) return 0;
  if (v==hr.v1) return 1-hr.u1; else return 1-hr.u2;
}

int Use(int v, int kd) { // pouzi tuto hranu
  thrana hr=E[V[v][kd]];
  
  if (JeFree(v,kd)) {
    used[hr.v1]++; used[hr.v2]++; 
    if (used[hr.v1]==deg[hr.v1]) kde[hr.v1]=0; 
    if (used[hr.v2]==deg[hr.v2]) kde[hr.v2]=0; 
  }
  if (hr.v1==v) {
    E[V[v][kd]].u1=1; 
    if (prichod[hr.v2]==-1) prichod[hr.v2]=V[v][kd];
    return hr.v2;
  } else {
    E[V[v][kd]].u2=1; 
    if (prichod[hr.v1]==-1) prichod[hr.v1]=V[v][kd];
    return hr.v1;
  }
}

int main(void){
  close(0);
  open("roury.in", O_RDONLY);
  close(1);
  open("roury.out", O_WRONLY|O_CREAT|O_TRUNC, 0666);
  // nacitame vstup 
  scanf("%d %d ",&N,&M);
  for (i=1;i<=N;i++) { sef[i]=i; kde[i]=0; }
  E=malloc((M+MAXN+1)*sizeof(thrana));
  for (i=0;i<M;i++) {
    scanf("%d %d ",&E[i].v1,&E[i].v2);
    E[i].u1=E[i].u2=E[i].del=0;
    deg[E[i].v1]++;
    deg[E[i].v2]++;
    // robime komponenty union-findom, ved co uz
    w1=Sef(E[i].v1); w2=Sef(E[i].v2);
    if (w1!=w2) {
      sef[w1]=w2;
    }
  }
  // zistime pocet parnych komponent
  for (i=1;i<=N;i++) if (deg[i]%2) kde[Sef(i)]=1;
    // neratame vrcholy stupna 0
    for (i=1;i<=N;i++) if (!deg[i]) kde[i]=1;
  P=0;
  for (i=1;i<=N;i++) if ((i==sef[i])&&(kde[i]==0)) P++;
  // pridame hrany z neparnych vrcholov
  j=R=0;
  for (i=1;i<=N;i++) {
    if (deg[i]%2) { ww[j]=i; j++; 
      if (j==2) {
        j=0; E[M].v1=ww[0]; E[M].v2=ww[1];
        E[M].u1=E[M].u2=0;  E[M].del=1;
        deg[E[M].v1]++; deg[E[M].v2]++;
        M++; R++;
      }
    }
  }
  // uz vieme, kolko tahov treba:
  printf("%d\n",R+P);
  // preformatujeme vstup
  // pre kazdy vrchol si pamatame jeho okolie
  for (i=1;i<=N;i++) 
    { used[i]=0; V[i]=malloc((deg[i]+2)*sizeof(int)); }
  for (i=0;i<M;i++) {
    w1=E[i].v1; w2=E[i].v2; 
    V[w1][used[w1]]=i; V[w2][used[w2]]=i;
    used[w1]++; used[w2]++;
  }
  for (i=1;i<=N;i++) used[i]=kde[i]=0;
    // vyhodime vrcholy stupna 0
    for (i=1;i<=N;i++) if (!deg[i]) used[i]=1;
  for (i=1;i<=N;i++) prichod[i]=-1;
  // hladame tah
  tah=malloc((M+1)*sizeof(ttah));
  for (start=1;start<=N;start++) if (used[start]==0) {
    v=start; tahl=0; prichod[v]=-2;
    while (1) {
      if (used[v]<deg[v]) {
        // ideme nepouzitou hranou
        while (!JeFree(v,kde[v])) kde[v]++;
        v=Use(v,kde[v]);
      } else {
        // ideme pouzitou hranou
        while ((kde[v]<deg[v]) && (!Mozem(v,kde[v]))) kde[v]++;
        if (kde[v]<deg[v]) {
          tah[tahl].from=v;
          tah[tahl].del=E[V[v][kde[v]]].del;
          tah[tahl++].to=E[V[v][kde[v]]].v1+E[V[v][kde[v]]].v2-v;
          v=Use(v,kde[v]);
        } else {
          // ideme hranou prveho prichodu
          if (prichod[v]==-2) break; // koniec tahu
          kde[v]=0; while (V[v][kde[v]]!=prichod[v]) kde[v]++;
          tah[tahl].from=v;
          tah[tahl].del=E[V[v][kde[v]]].del;
          tah[tahl++].to=E[V[v][kde[v]]].v1+E[V[v][kde[v]]].v2-v;
          v=Use(v,kde[v]);
        }
      }
    }
    zle=0; for (i=0;i<tahl;i++) if (tah[i].del) zle++;
    if (zle==0) {
      // vypiseme cely tah
      printf("%d",tah[0].from);
      for (i=0;i<tahl;i++) printf(" %d",tah[i].to); printf("\n");
    } else {
      // vyhodime z neho zle hrany, vypiseme tahy a pokracujeme
      j=0; while (!tah[j].del) j++; j++;
      while (zle>0) {
        printf("%d",tah[j].from);
        while (!tah[j].del) {
          printf(" %d",tah[j].to);
          j++; if (j==tahl) j=0;
        }
        printf("\n"); zle--;
        j++; if (j==tahl) j=0;
      }
    }
  }
  
  free(E); for (i=1;i<=N;i++) free(V[i]); free(tah);
  return 0;
}
