/*
 * testovac pre RURY
 * (c) MisoF
 *
 * parametre: nazvy suborov v tomto poradi
 * - vstup
 * - vzorovy vystup
 * - testovany vystup
 */

#include <stdio.h>
#include <stdlib.h>

#define MY_ERR 1
#define ERR 1
#define OKAY 0
#define MAXN 507

FILE *fin,*ftst,*fout;
int mytahov,ontahov,tah;
int N,M,i,j,x,y,poc;
int *G[MAXN];
char *row, *kde, last;
char items[125000][5];
int numbers[125000];

void Vycisti(void){
  // uprace po sebe
  fclose(fin); fclose(fout); fclose(ftst);
  for (i=0;i<=N;i++) free(G[i]);
  free(row);
}

int main(int argc, char **argv){

  // pootvarame si subory, ak to nejde, hlasime chybu

  fin=fopen(argv[1],"rt");
  ftst=fopen(argv[2],"rt");
  fout=fopen(argv[3],"rt");
  row=(char *)malloc(500000);

  if ((fin==NULL)||(ftst==NULL)) {
    printf("INTERNA CHYBA -- neviem otvorit nas subor!\n");
    Vycisti();
    return MY_ERR;
  }
  if (fout==NULL) {
    printf("Chyba vystup.\n");
    Vycisti();
    return ERR;
  }

  // podarilo sa vsetko otvorit, porovname pocet robotov

  fscanf(ftst,"%d ",&mytahov);
  fgets(row,499999,fout); fscanf(fout," ");
  if (sscanf(row,"%d",&ontahov)<1) {
    printf("Chyba pocet robotov.\n");
    Vycisti();
    return ERR;
  }
  if (ontahov>mytahov) {
    printf("Viac robotov (%d) ako treba (%d).\n",ontahov,mytahov);
    Vycisti();
    return ERR;
  }

  // nacitame si graf

  fscanf(fin,"%d %d ",&N,&M);
  for (i=0;i<=N;i++) G[i]=(int *)malloc((N+3)*sizeof(int));
  for (i=0;i<=N;i++) for (j=0;j<=N;j++) G[i][j]=0;
  for (i=0;i<M;i++) {
    fscanf(fin,"%d %d ",&x,&y);
    G[x][y]=1; G[y][x]=1;
  }

  // skontrolujeme, ci su jeho tahy korektne

  tah=0;
  while (!feof(fout)) {
    tah++;

    fgets(row,499999,fout); fscanf(fout," ");

    // nacitali sme riadok, ideme ho rozsekat
    kde=row; // prvy nacitany znak je urcite >=32 kvoli fscanf(fout," ");
    items[0][0]=kde[0]; x=0; y=1;
    last=kde[0]; kde++;
    while (kde[0]) {
      if (kde[0]<=32) {
        if (last>32) {
          items[x][y]=0;
          x++; y=0;
        }
        last=kde[0]; kde++;
      } else {
        items[x][y]=kde[0];
        y++;
        if (y==4) {
          printf("Chyba v tahu %d.\n",tah);
          Vycisti();
          return ERR;
        }
        last=kde[0]; kde++;
      }
    }
    poc=x;

    for (i=0;i<poc;i++) numbers[i]=atoi(items[i]);
    for (i=0;i<poc;i++) if ((numbers[i]<1)||(numbers[i]>N)) {
      printf("Zle cislo (%d) v tahu %d.\n",numbers[i],tah);
      Vycisti();
      return ERR;
    }
    
    for (i=0;i<poc-1;i++) {
      x=numbers[i]; y=numbers[i+1];
      if (G[x][y]==0) {
        printf("Zla hrana %d-%d v tahu %d.\n",x,y,tah);
        Vycisti();
        return ERR;
      }
      if (G[x][y]==2) {
        printf("Ide dvakrat hranou %d-%d.\n",x,y);
        Vycisti();
        return ERR;
      }
      G[x][y]=2;
      G[y][x]=2;
    }
  }

  // a ci presiel vsetko
  for (i=1;i<=N;i++) for (j=1;j<=N;j++) if (G[i][j]==1) {
    printf("Nesiel ani raz hranou %d-%d.\n",i,j);
    Vycisti();
    return ERR;
  }
  if (tah!=ontahov) {
    printf("Ma %d robotov, ale %d tras.\n",ontahov,tah);
    Vycisti();
    return ERR;
  }

  // pre istotu -- ak to ma OK a ma menej tahov ako my, interna chyba
  if (ontahov<mytahov) {
    printf("INTERNA CHYBA -- menej robotov (%d) ako my (%d)!\n",ontahov,mytahov);
    Vycisti();
    return MY_ERR;
  }

  // inac OK
  Vycisti();
  printf("OK.\n");
  return OKAY;
}
